git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: David Aguilar <davvid@gmail.com>
To: gitster@pobox.com
Cc: git@vger.kernel.org, David Aguilar <davvid@gmail.com>
Subject: [PATCH 7/8] mergetool: refactor git-mergetool to use run_merge_tool
Date: Sun, 29 Mar 2009 22:03:47 -0700	[thread overview]
Message-ID: <1238389428-69328-8-git-send-email-davvid@gmail.com> (raw)
In-Reply-To: <1238389428-69328-7-git-send-email-davvid@gmail.com>

This removes most of the duplicated code in git-mergetool.

Signed-off-by: David Aguilar <davvid@gmail.com>
---
 git-mergetool.sh |  106 ++----------------------------------------------------
 1 files changed, 3 insertions(+), 103 deletions(-)

diff --git a/git-mergetool.sh b/git-mergetool.sh
index ec20030..0f5033c 100755
--- a/git-mergetool.sh
+++ b/git-mergetool.sh
@@ -191,109 +191,9 @@ merge_file () {
 		read ans
 	fi
 
-	case "$merge_tool" in
-	kdiff3)
-		if base_present ; then
-			("$merge_tool_path" --auto \
-				--L1 "$MERGED (Base)" \
-				--L2 "$MERGED (Local)" \
-				--L3 "$MERGED (Remote)" \
-				-o "$MERGED" "$BASE" "$LOCAL" "$REMOTE" \
-			 > /dev/null 2>&1)
-		else
-			("$merge_tool_path" --auto \
-				--L1 "$MERGED (Local)" \
-				--L2 "$MERGED (Remote)" \
-				-o "$MERGED" "$LOCAL" "$REMOTE" \
-			 > /dev/null 2>&1)
-		fi
-		status=$?
-		;;
-	tkdiff)
-		if base_present ; then
-			"$merge_tool_path" -a "$BASE" -o "$MERGED" "$LOCAL" "$REMOTE"
-		else
-			"$merge_tool_path" -o "$MERGED" "$LOCAL" "$REMOTE"
-		fi
-		status=$?
-		;;
-	meld)
-		touch "$BACKUP"
-		"$merge_tool_path" "$LOCAL" "$MERGED" "$REMOTE"
-		check_unchanged
-		;;
-	vimdiff)
-		touch "$BACKUP"
-		"$merge_tool_path" -c "wincmd l" "$LOCAL" "$MERGED" "$REMOTE"
-		check_unchanged
-		;;
-	gvimdiff)
-		touch "$BACKUP"
-		"$merge_tool_path" -c "wincmd l" -f "$LOCAL" "$MERGED" "$REMOTE"
-		check_unchanged
-		;;
-	xxdiff)
-		touch "$BACKUP"
-		if base_present ; then
-			"$merge_tool_path" -X --show-merged-pane \
-				-R 'Accel.SaveAsMerged: "Ctrl-S"' \
-				-R 'Accel.Search: "Ctrl+F"' \
-				-R 'Accel.SearchForward: "Ctrl-G"' \
-				--merged-file "$MERGED" "$LOCAL" "$BASE" "$REMOTE"
-		else
-			"$merge_tool_path" -X --show-merged-pane \
-				-R 'Accel.SaveAsMerged: "Ctrl-S"' \
-				-R 'Accel.Search: "Ctrl+F"' \
-				-R 'Accel.SearchForward: "Ctrl-G"' \
-				--merged-file "$MERGED" "$LOCAL" "$REMOTE"
-		fi
-		check_unchanged
-		;;
-	opendiff)
-		touch "$BACKUP"
-		if base_present; then
-			"$merge_tool_path" "$LOCAL" "$REMOTE" \
-				-ancestor "$BASE" -merge "$MERGED" | cat
-		else
-			"$merge_tool_path" "$LOCAL" "$REMOTE" \
-				-merge "$MERGED" | cat
-		fi
-		check_unchanged
-		;;
-	ecmerge)
-		touch "$BACKUP"
-		if base_present; then
-			"$merge_tool_path" "$BASE" "$LOCAL" "$REMOTE" \
-				--default --mode=merge3 --to="$MERGED"
-		else
-			"$merge_tool_path" "$LOCAL" "$REMOTE" \
-				--default --mode=merge2 --to="$MERGED"
-		fi
-		check_unchanged
-		;;
-	emerge)
-		if base_present ; then
-			"$merge_tool_path" -f emerge-files-with-ancestor-command \
-				"$LOCAL" "$REMOTE" "$BASE" "$(basename "$MERGED")"
-		else
-			"$merge_tool_path" -f emerge-files-command \
-				"$LOCAL" "$REMOTE" "$(basename "$MERGED")"
-		fi
-		status=$?
-		;;
-	*)
-		if test -n "$merge_tool_cmd"; then
-			if test "$merge_tool_trust_exit_code" = "false"; then
-				touch "$BACKUP"
-				( eval $merge_tool_cmd )
-				check_unchanged
-			else
-				( eval $merge_tool_cmd )
-				status=$?
-			fi
-		fi
-		;;
-	esac
+	run_merge_tool "$merge_tool"
+	status=$?
+
 	if test "$status" -ne 0; then
 		echo "merge of $MERGED failed" 1>&2
 		mv -- "$BACKUP" "$MERGED"
-- 
1.6.1.3

  reply	other threads:[~2009-03-30  5:06 UTC|newest]

Thread overview: 19+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2009-03-30  5:03 (unknown), David Aguilar
2009-03-30  5:03 ` [PATCH 1/8] mergetool: use tabs consistently David Aguilar
2009-03-30  5:03   ` [PATCH 2/8] mergetool: use $( ... ) instead of `backticks` David Aguilar
2009-03-30  5:03     ` [PATCH 3/8] sh-tools: add a git-sh-tools shell helper script David Aguilar
2009-03-30  5:03       ` [PATCH 4/8] mergetool: refactor git-mergetool to use git-sh-tools David Aguilar
2009-03-30  5:03         ` [PATCH 5/8] difftool: refactor git-difftool " David Aguilar
2009-03-30  5:03           ` [PATCH 6/8] sh-tools: add a run_merge_tool function David Aguilar
2009-03-30  5:03             ` David Aguilar [this message]
2009-03-30  5:03               ` [PATCH 8/8] difftool: refactor git-difftool-helper to use run_merge_tool David Aguilar
2009-03-30  6:55             ` [PATCH 6/8] sh-tools: add a run_merge_tool function Markus Heidelberg
2009-03-30  7:32             ` Markus Heidelberg
2009-03-30  7:46               ` David Aguilar
2009-03-30  8:44   ` [PATCH 1/8] mergetool: use tabs consistently Junio C Hamano
2009-03-30  9:22     ` David Aguilar
2009-03-30 21:35     ` Charles Bailey
2009-03-31  6:36       ` David Aguilar
2009-04-01 17:56         ` Junio C Hamano
2009-03-30  7:02 ` Markus Heidelberg
2009-03-30  8:46   ` Re: Junio C Hamano

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1238389428-69328-8-git-send-email-davvid@gmail.com \
    --to=davvid@gmail.com \
    --cc=git@vger.kernel.org \
    --cc=gitster@pobox.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).